/*
 * Copyright (C) Yao Jun 2011
 * -- nter@tom.com
 * -- http://CortOS.sourceforge.net/
 *
 * SortOS is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SortOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#ifndef   __CORTOS_COMMON_H
#define   __CORTOS_COMMON_H

#define CORT_OS_STATUS_TIMING		0x01
#define CORT_OS_STATUS_INTERRUP		0x02
#define CORT_OS_STATUS_SCHEDLOCK	0x04

#define CORT_TK_STATUS_READY		0x01
#define CORT_TK_STATUS_RUN			0x02
#define CORT_TK_STATUS_SUSPEND		0x03
#define CORT_TK_STATUS_WAITING		0x04
#define CORT_TK_STATUS_DELETE		0x05
#define CORT_TK_STATUS_ERROR		0xff

extern t_timer *CORT_TimerList;
extern t_u16    CORT_CPUUsageVal;
extern t_u8     CORT_OSStatus;
extern t_u32    CORT_TickCnt;

extern t_task  *CORT_CurTcb;
extern t_bool   CORT_Running;
extern t_u8     CORT_CurPrio;
extern t_u8     CORT_HighPrio;
extern t_prio   CORT_ReadyTable;
extern t_tskid  CORT_HeapNum;
extern t_task  *CORT_HeapFirst;

extern t_tklist CORT_AliveList;
extern t_tklist CORT_FreeList;

extern t_u8     CORT_IntNesting;
extern t_hook   CORT_Hook;

extern void     CORT_CommInit(void);
extern void     CORT_MemSet(void *pMem, t_u8 val, t_size size);
extern void     CORT_ListInsert(t_tklist *pList, t_tkitem *pItem);
extern void     CORT_ListRemove(t_tklist *pList, t_tkitem *pItem);
extern void     CORT_ClearStk(t_stk * pstk, t_size size);
extern void     CORT_CalcTaskStk(t_task * ptcb);
extern void     CORT_CheckTaskStk(t_task * ptcb);
extern void     CORT_TaskError(t_task * ptcb);
extern void     CORT_CreateOSTask(void);
extern void     CORT_SearchRdy(void);
extern t_u8     CORT_CheckFlag(t_u32 *pval, t_u32 *flag, t_u32 mask, t_u8 oper);
extern t_void   CORT_SwHighTask(void);

#endif

