/*
 * Copyright (C) Yao Jun 2011
 * <nter@tom.com> 
 * <http://CortOS.sourceforge.net/>
 *
 * SortOS is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SortOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contents:
 */

#include "cortos.h"

#define CORT_VERSION_CNT (CORT_KERNEL_LITE + CORT_KERNEL_FULL)
#define CORT_DAI_PROTECT (CORT_DAI_READ_PROTECT_EN | CORT_DAI_WRITE_PROTECT_EN | CORT_DAI_IOCTRL_PROTECT_EN)

#if (CORT_STAT_PRE_SEC > (CORT_TICK_PER_SEC/10))
	#error "CORT_STAT_PRE_SEC < (CORT_TICK_PER_SEC/10)"
#endif

#if  (CORT_VERSION_CNT > 1) || (CORT_VERSION_CNT == 0)
	#error "CORT_VERSION_CNT == 1"
#endif

#if (CORT_LOWEST_PRIO > 31)
	#error "CORT_LOWEST_PRIO) == 31"
#endif

#if (CORT_LOWEST_PRIO > CORT_PORTING_MINPRIO)
	#error "CORT_LOWEST_PRIO <= CORT_PORTING_MINPRIO"
#endif

#if (CORT_MAX_TASK > CORT_PORTING_MAXTASK)
	#error "CORT_MAX_TASK <= CORT_PORTING_MAXTASK"
#endif

#if (CORT_DAI_EN && CORT_DAI_PROTECT && !CORT_SEM_EN)
	#error "Must be define CORT_SEM_EN"
#endif

