/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : Jun Yao
* Email							 : nter@tom.com
* Version            : V1.0
* Date               : 07/22/2008
* Description        : Main program body
********************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "config.h"
#include "test_comm.c"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define TASK_STK_SIZE	128
#define TASK_MAIN_PRIO	1

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
t_stk STK_TASK_MAIN[TASK_STK_SIZE];

/*******************************************************************************
* Function Name  : MainTask
* Description    : Main Task
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MainTask(void *pd)
{
	dev_uart_1_init();
	dev_hwinit_start();
	
	CORT_StateGo();

	CORT_Printf_Init();

	CORT_Printf("Description	              Space\n");
	CORT_Printf("RAM Space for a Task         %d\n", sizeof(t_task));
	CORT_Printf("RAM Space for a Semaphore    %d\n", sizeof(t_sem));
	CORT_Printf("RAM Space for a Queue        %d\n", sizeof(t_queue));
	CORT_Printf("RAM Space for a Pipe         %d\n", sizeof(t_pipe));
	CORT_Printf("RAM Space for a Mailbox      %d\n", sizeof(t_mailbox));
	CORT_Printf("RAM Space for a Flag         %d\n", sizeof(t_flag));
	CORT_Printf("RAM Space for a User Timer   %d\n", sizeof(t_timer));

	while(1)
	{
		CORT_Task_Delay(1);
	}
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void)
{
	dev_hwinit_init();
	
	CORT_Init();
	CORT_Task_Create (MainTask, 0, STK_TASK_MAIN, sizeof(STK_TASK_MAIN), TASK_MAIN_PRIO, "MainTask", m_null);
	CORT_Start();
}

