/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : Jun Yao
* Email							 : nter@tom.com
* Version            : V1.0
* Date               : 07/22/2008
* Description        : Main program body
********************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "config.h"
#include "test_comm.c"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define TASK_STK_SIZE	128
#define TASK_TEST1_PRIO	1
#define TASK_TEST2_PRIO	2
#define TASK_MAIN_PRIO	3

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
t_stk STK_TASK_MAIN[TASK_STK_SIZE];
t_stk STK_TASK_TEST1[TASK_STK_SIZE];
t_stk STK_TASK_TEST2[TASK_STK_SIZE];

/*******************************************************************************
* Function Name  : MainTask
* Description    : Main Task
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void TestTask1(void *pd)
{
	t_u32 i = 0;
	while(1)
	{
		for(i=0;i<100;i++);
		CORT_Task_Delay(10);	
	}
}
void TestTask2(void *pd)
{
	t_u32 i = 0;
	while(1)
	{
		for(i=0;i<1000;i++);
		CORT_Task_Delay(10);
	}
}
/*******************************************************************************
* Function Name  : MainTask
* Description    : Main Task
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MainTask(void *pd)
{
	t_tasksta sta1,sta2;
	t_tskid threadID1,threadID2;

	dev_uart_1_init();
	dev_hwinit_start();
	
	CORT_StateGo();

	CORT_Printf_Init();
	
	CORT_Task_Create (TestTask1, 0, STK_TASK_TEST1, sizeof(STK_TASK_TEST1), TASK_TEST1_PRIO, "TestTask1", &threadID1);
	CORT_Task_Create (TestTask2, 0, STK_TASK_TEST2, sizeof(STK_TASK_TEST2), TASK_TEST2_PRIO, "TestTask2", &threadID2);

	while(1)
	{
		CORT_Task_Delay(100);
		
		CORT_Task_GetState(threadID1, &sta1);
		CORT_Task_GetState(threadID2, &sta2);
		CORT_Printf("Task1:%dus    Task2:%dus\r\n", sta1.ts_rtim_usec, sta2.ts_rtim_usec);
	}
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void)
{
	dev_hwinit_init();
	
	CORT_Init();
	CORT_Task_Create (MainTask, 0, STK_TASK_MAIN, sizeof(STK_TASK_MAIN), TASK_MAIN_PRIO, "MainTask", m_null);
	CORT_Start();
}
