/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : Jun Yao
* Email							 : nter@tom.com
* Version            : V1.0
* Date               : 07/22/2008
* Description        : Main program body
********************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "config.h"
#include "test_comm.c"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define TASK_STK_SIZE	128
#define TASK_MAIN_PRIO	1

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
t_stk STK_TASK_MAIN[TASK_STK_SIZE];
t_timer timer1;
t_timer timer2;

/*******************************************************************************
* Function Name  : Timer
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MyTimer(t_u8 flag, t_bool bEnd)
{
	CORT_Printf("Timer %d\n", flag);
}
/*******************************************************************************
* Function Name  : MainTask
* Description    : Main Task
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MainTask(void *pd)
{
	dev_uart_1_init();
	dev_hwinit_start();
	
	CORT_StateGo();

	CORT_Printf_Init();
	
	CORT_Timer_Create(&timer1, 1, 1, 500, MyTimer);
	CORT_Timer_Create(&timer2, 2, 1, 100, MyTimer);

	while(1)
	{
#if TEST_DELETE
		switch(getchar())
		{
		case '1':
			CORT_Timer_Create(&timer1, 1, 1, 500, MyTimer);
			break;
		case '2':
			CORT_Timer_Delete(&timer1);
			break;
		case '3':
			CORT_Timer_Create(&timer2, 2, 1, 100, MyTimer);
			break;
		case '4':
			CORT_Timer_Delete(&timer2);
			break;
		}
#else
		CORT_Task_Delay(1);
#endif
		
	}
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void)
{
	dev_hwinit_init();
	
	CORT_Init();
	CORT_Task_Create (MainTask, 0, STK_TASK_MAIN, sizeof(STK_TASK_MAIN), TASK_MAIN_PRIO, "MainTask", m_null);
	CORT_Start();
}
