;
; Copyright (C) Yao Jun 2011
; <nter@tom.com> 
; <http://CortOS.sourceforge.net/>
;
; SortOS is free software: you can redistribute it and/or modify it
; under the terms of the GNU Lesser General Public License as published
; by the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
; 
; SortOS is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See the GNU Lesser General Public License for more details.
; 
; You should have received a copy of the GNU Lesser General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;

NVIC_INT_CTRL   	EQU     0xE000ED04
NVIC_SYSPRI2    	EQU     0xE000ED20
NVIC_PENDSV_PRI 	EQU     0xFFFF0000
NVIC_PENDSVSET  	EQU     0x10000000

	IMPORT  CORT_CurTcb
	IMPORT  CORT_IntNesting
	IMPORT  CORT_Running
	EXTERN  CORT_SwHighTask
	EXTERN  CORT_EnterInt
	EXTERN  CORT_ExitInt
	EXTERN  CORT_IntRoutine
	EXTERN  CORT_RTim_Run
	EXTERN  CORT_RTim_Stop


	AREA	|subr|, CODE, READONLY
	PRESERVE8
	
;////////////////////////////////////////////////////////////////////
	EXPORT 	CORT_CtxSw
CORT_CtxSw
	LDR     R0 , =NVIC_INT_CTRL				;rigger the PendSV exception (causes context switch)
	LDR     R1 , =NVIC_PENDSVSET
	STR     R1 , [R0]
	CPSIE	I
	NOP
	BX      LR

;////////////////////////////////////////////////////////////////////
	EXPORT 	CORT_StartHigh
CORT_StartHigh
	LDR     R4 , =NVIC_SYSPRI2				; set the PendSV exception priority
	LDR     R5 , =NVIC_PENDSV_PRI
	STR     R5 , [R4]

	LDR		R1 , =CORT_Running				; CORT_Running = 1
	MOVS    R2 , #1
	STRB    R2 , [R1]

	MOVS	R0 , #0
	MSR     PSP, R0
	LDR     R4 , =NVIC_INT_CTRL				;rigger the PendSV exception (causes context switch)
	LDR     R5 , =NVIC_PENDSVSET
	STR     R5 , [R4]
	CPSIE	I
	NOP
CORT_StartHighLoop
	B       CORT_StartHighLoop				;should never get here
		
;////////////////////////////////////////////////////////////////////
	EXPORT 	CORT_GlobalInt
CORT_GlobalInt
	CPSID	I	
;	if ((++CORT_IntNesting)==1)
	LDR		R1 , =CORT_IntNesting	   		 ; CORT_IntNesting++
	LDRB	R2 , [R1]
	ADDS   	R2 , #0x01
	STRB	R2 , [R1]
	CMP		R2 , #0x01
	BNE		ENTER_INTROUTINE
;	{
;		Save Stack Printer
		PUSH	{R4-R7}						; PUSH R4-R7
		MOV		R0 , R8
		MOV		R1 , R9
		MOV		R2 , R10
		MOV		R3 , R11
		PUSH	{R0-R3}						; PUSH	R8-R11
		MRS		R1 , MSP
		LDR		R2 , =CORT_CurTcb
		LDR		R2 , [R2]
		STR		R1 , [R2]

;		CORT_RTim_Stop();
		LDR		R1 , =CORT_RTim_Stop
		BLX		R1

;		CORT_EnterInt();
		LDR		R1 , =CORT_EnterInt
		BLX		R1
;	}
ENTER_INTROUTINE
;	CORT_IntRoutine();
	MRS		R0 , IPSR
	LDR		R1 , =CORT_IntRoutine
	BLX		R1
	CPSID	I									;disable interrupts at processor level

;	if ((--CORT_IntNesting))
	LDR		R1 , =CORT_IntNesting				;CORT_IntNesting++
	LDRB	R2 , [R1]
 	SUBS	R2 , #0x01
	STRB	R2 , [R1]
	CMP		R2 , #0x00
	BEQ		ENTER_TASK
;	{
;		return;
		MOVS	R0, #0
		SUBS	R0, #7
		MOV		LR, R0							; LR = #0xfffffff9
		CPSIE	I								;enable interrupts at processor level
		BX		LR								;return thread mode
;	}else{
ENTER_TASK
;		CORT_ExitInt();
		LDR		R1 , =CORT_ExitInt
		BLX		R1
;		CORT_SwHighTask();
		LDR		R1 , =CORT_SwHighTask
		BLX		R1
;		CORT_RTim_Run();
		LDR		R1 , =CORT_RTim_Run
		BLX		R1
;		Load Stack Printer
		LDR		r0 , =CORT_CurTcb
		LDR		r0 , [R0]
		LDR		r0 , [R0]
		MSR		MSP, R0
;		Switch Task
		POP		{R0-R3}							; POP R8-R11
		MOV		R8 , R0
		MOV		R9 , R1
		MOV		R10, R2
		MOV		R11, R3
		POP		{R4-R7}							; POP R4-R7

		MOVS	R0, #0
		SUBS	R0, #7
		MOV		LR, R0							; LR = #0xfffffff9
		CPSIE	I								;enable interrupts at processor level
		BX		LR								;return thread mode
;	}
;////////////////////////////////////////////////////////////////////
	EXPORT 	CORT_PendSV
CORT_PendSV
	CPSID	I
	MRS		R1 , PSP
	MOVS	R0 , #4
	MSR     PSP, R0
	CMP		R1 , #0x00
	BEQ		CORT_PendSV_nosave
	
;	Save Stack Printer
	PUSH	{R4-R7}						; PUSH R4-R7
	MOV		R0 , R8
	MOV		R1 , R9
	MOV		R2 , R10
	MOV		R3 , R11
	PUSH	{R0-R3}						; PUSH	R8-R11
	
	MRS		R1 , MSP
	LDR		r0 , =CORT_CurTcb
	LDR		r0 , [r0]
	STR		R1 , [r0]

;	CORT_RTim_Stop();
	LDR		R1 , =CORT_RTim_Stop
	BLX		R1

CORT_PendSV_nosave
;	CORT_SwHighTask();
	LDR		R1 , =CORT_SwHighTask
	BLX		R1

;	CORT_RTim_Run();
	LDR		R1 , =CORT_RTim_Run
	BLX		R1

;	Load Stack Printer
	LDR		r0 , =CORT_CurTcb
	LDR		r0 , [R0]
	LDR		r0 , [R0]
	MSR		MSP, R0
	
;	Switch Task
	POP		{R4-R7}							; POP R8-R11
	MOV		R8 , R4
	MOV		R9 , R5
	MOV		R10, R6
	MOV		R11, R7
	POP		{R4-R7}							; POP R4-R7
	
	MOVS	R0, #0
	SUBS	R0, #7
	MOV		LR, R0							; LR = #0xfffffff9
;	CPSIE	I								;enable interrupts at processor level
	BX		LR								;return thread mode

	ALIGN
	END
	
