/*
 * Copyright (C) Yao Jun 2011
 * <nter@tom.com> 
 * <http://CortOS.sourceforge.net/>
 *
 * SortOS is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SortOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contents:
 *   CORT_IntEntry()       - 
 */

#include "cortos.h"

t_u32 mt_IntIdx = 0;
typedef void (*interrupt_handler_t)(t_u16);

void HardFaultHandler(void)
{
	while(1);
}
static t_u16 erridx = 0xffff;
void NonHandledInterrupt(t_u16 idx)
{
	erridx = idx;
	erridx = erridx;
	while(1);
}

static interrupt_handler_t vec_tab[] = {
	{(interrupt_handler_t)NonHandledInterrupt}, // 0 Top of Stack
    {(interrupt_handler_t)NonHandledInterrupt}, // 1 Reset Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 2 NMI Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 3 Hard Fault Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 4 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, // 5 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, // 6 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, // 7 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, // 8 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, // 9 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, //10 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, //11 SVCall Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //12 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, //13 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, //14 PendSV Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //15 SysTick Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //16 BOD_IRQHandler  
    {(interrupt_handler_t)NonHandledInterrupt}, //17 WDT_IRQHandler  
    {(interrupt_handler_t)NonHandledInterrupt}, //18 EINT0_IRQHandler
    {(interrupt_handler_t)NonHandledInterrupt}, //19 EINT1_IRQHandler
    {(interrupt_handler_t)NonHandledInterrupt}, //20 GPIOP0P1_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //21 GPIOP2P3P4_IRQHandler
    {(interrupt_handler_t)NonHandledInterrupt}, //22 PWMA_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //23 PWMB_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //24 TMR0_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //25 TMR1_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //26 TMR2_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //27 TMR3_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //28 UART0_IRQHandler
    {(interrupt_handler_t)NonHandledInterrupt}, //29 UART1_IRQHandler
    {(interrupt_handler_t)NonHandledInterrupt}, //30 SPI0_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //31 SPI1_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //32 SPI2_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //33 SPI3_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //34 I2C_IRQHandler 
    {(interrupt_handler_t)NonHandledInterrupt}, //35 Default_Handler 
    {(interrupt_handler_t)NonHandledInterrupt}, //36 Default_Handler 
    {(interrupt_handler_t)NonHandledInterrupt}, //37 Default_Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //38 Default_Handler 
    {(interrupt_handler_t)NonHandledInterrupt}, //39 Default_Handler  
    {(interrupt_handler_t)NonHandledInterrupt}, //40 Default_Handler  
    {(interrupt_handler_t)NonHandledInterrupt}, //41 Default_Handler 
    {(interrupt_handler_t)NonHandledInterrupt}, //42 Default_Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //43 Default_Handler 
    {(interrupt_handler_t)NonHandledInterrupt}, //44 PWRWU_IRQHandler
    {(interrupt_handler_t)NonHandledInterrupt}, //45 ADC_IRQHandler
    {(interrupt_handler_t)NonHandledInterrupt}, //46 Default_Handler  
    {(interrupt_handler_t)NonHandledInterrupt}, //47 Default_Handler  
};

/*
**
*/
void CORT_IntRoutine(t_u8 id)
{
	if (id > 1 && id < CORT_ARRAYSIZE(vec_tab)){
		vec_tab[id](id);
	}
}

/*
**
*/
t_s8  CORT_Interrupt_Register(t_u16 idx,void (*task_entry)(t_u16))
{
	CORT_EnterCritical();
	if (idx > 1 && idx < CORT_ARRAYSIZE(vec_tab))
	{
		vec_tab[idx] = task_entry;
		CORT_ExitCritical();
		return CORT_OK;
	}
	CORT_ExitCritical();
	return CORT_ERROR;
}
