#include "config.h"

extern void CORT_Tick(void);

/*
**
*/
static t_u16 dev_hwinit_rtmcnt(void)
{
	return TIM1->CNT;
}

/*
**  Interrupt for System tick
*/
static void dev_hwinit_sleep(void)
{
	PWR->CR &= ~6;
	__WFI();
}

/*
**  Interrupt for System tick
*/
void dev_hwinit_tick(t_u16 idx)
{
	/* System tick */
	CORT_Tick();
}

void NVIC_Configuration(void)
{
	/* Set the Vector Table base location at 0x08000000 */ 
	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
}

/*
**
*/
void dev_hwinit_timer(void)
{
	RCC_ClocksTypeDef clk;
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);

	RCC_GetClocksFreq(&clk);
	
	/* Time base configuration */
	TIM_TimeBaseStructure.TIM_Period = 0xffff;
	TIM_TimeBaseStructure.TIM_Prescaler = (clk.PCLK2_Frequency/1000000)-1;
	TIM_TimeBaseStructure.TIM_ClockDivision = 0;    
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; 
	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);

	/* TIM enable counter */
	TIM_Cmd(TIM1, ENABLE);
}

/*
**  Initialize Hardware
*/
void dev_hwinit_init(void)
{
	CORT_Interrupt_Register(15, dev_hwinit_tick);
	
	/* System Clocks Configuration */
	SystemInit();

	/* Enable Clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
  
	/* NVIC configuration */
	NVIC_Configuration();
}
/*
** Start timer
*/
void dev_hwinit_start(void)
{
	t_hook hook = {0};
	RCC_ClocksTypeDef RCC_Clocks;

	hook.hk_sleep = dev_hwinit_sleep;
	hook.hk_rtmcnt = dev_hwinit_rtmcnt;
	
	CORT_Hook_RegCall(&hook);

	RCC_GetClocksFreq(&RCC_Clocks);
	SysTick_Config(RCC_Clocks.HCLK_Frequency / 8000);
  
	dev_hwinit_timer();
}

