/*
 * Copyright (C) Yao Jun 2011
 * <nter@tom.com> 
 * <http://CortOS.sourceforge.net/>
 *
 * SortOS is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SortOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#ifndef   __CORTOS_CPU_H
#define   __CORTOS_CPU_H

/* ---------------------- Porting Limit Description----------------------------------- */
#define CORT_PORTING_MINPRIO         31 /* Lost Priority for Porting                   */
#define CORT_PORTING_MAXTASK        255 /* Number of Task for Porting                  */
#define CORT_PORTING_STK_GROWTH       1 /* Stack grows from HIGH to LOW memory on arm  */
/* --------------------------  Variable Type ----------------------------------------- */
typedef unsigned long         t_u32;
typedef signed long           t_s32;
typedef unsigned short        t_u16;
typedef signed short          t_s16;
typedef unsigned char         t_u8;
typedef signed char           t_s8;
typedef char                  t_bool;
typedef void                  t_void;
typedef t_u32                 t_size;
typedef t_u32                 t_stk;
typedef t_u32                 t_prio;
typedef t_u8                  t_tskid;
/* ---------------------- Porting Special Interface ---------------------------------- */
extern t_stk *CORT_InitStk(void (*task)(void *p_arg), void *parg, t_stk *pstk, t_size size);
extern void   CORT_CtxSw(void);
extern void   CORT_IntCtxSw(void);
extern void   CORT_StartHigh(void);
extern t_u8   CORT_CountLeadZeros(t_prio val);

#define CORT_EnterCritical()	__disable_irq()
#define CORT_ExitCritical()		__enable_irq()

/* ------------------------------------------------------------------------------------*/

#endif	//#ifndef   __CORTOS_CPU_H

