/*
 * Copyright (C) Yao Jun 2013
 * <nter@tom.com> 
 * <http://CortOS.sourceforge.net/>
 *
 * SortOS is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SortOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "config.h"
#include "cortos_common.h"

/*
**
*/
t_stk *CORT_InitStk(t_void (*task)(t_void *p_arg), t_void *parg, t_stk *pstk, t_size size)
{
    t_u32 i,*stk = &pstk[size/4];

	*(--stk) = (t_u32)0xDDuL;                  /* Reserved */
	*(--stk) = (t_u32)0xDDuL;                  /* FPSCR */
	for(i = 0; i < 16; i++)
	{
		*(--stk) = (t_u32)0xAAAAAAAAuL;
	}
    
	*(--stk)  = (t_u32)0x21000000L;            /* xPSR */
	*(--stk)  = (t_u32)task;                   /* Entry Point */
	*(--stk)  = (t_u32)0xFFFFFFFEL;            /* R14 (LR) */
	*(--stk)  = (t_u32)0x12121212L;            /* R12 */
	*(--stk)  = (t_u32)0x03030303L;            /* R3 */
	*(--stk)  = (t_u32)0x02020202L;            /* R2 */
	*(--stk)  = (t_u32)0x01010101L;            /* R1 */
	*(--stk)  = (t_u32)parg;                   /* R0 : argument */
	
	*(--stk)  = (t_u32)0x11111111L;            /* R11 */
	*(--stk)  = (t_u32)0x10101010L;            /* R10 */
	*(--stk)  = (t_u32)0x09090909L;            /* R9 */
	*(--stk)  = (t_u32)0x08080808L;            /* R8 */
	*(--stk)  = (t_u32)0x07070707L;            /* R7 */
	*(--stk)  = (t_u32)0x06060606L;            /* R6 */
	*(--stk)  = (t_u32)0x05050505L;            /* R5 */
	*(--stk)  = (t_u32)0x04040404L;            /* R4 */

	for (i = 0u; i < 16; i++)                  /* Initialize general-purpose Floating point registers  */
    {
		*(--stk) = (t_u32)0xBBBBBBBBuL;        /* S16-S31 */
    }
	
    return (stk);
}

