/*
 * Copyright (C) Yao Jun 2011
 * <nter@tom.com> 
 * <http://CortOS.sourceforge.net/>
 *
 * SortOS is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SortOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contents:
 *   CORT_IntEntry()       - 
 */

#include "cortos.h"

t_u32 mt_IntIdx = 0;
typedef void (*interrupt_handler_t)(t_u16);

void HardFaultHandler(void)
{
	while(1);
}
static t_u16 erridx = 0xffff;
void NonHandledInterrupt(t_u16 idx)
{
	erridx = idx;
	erridx = erridx;
	while(1);
}

static interrupt_handler_t vec_tab[] = {
	{(interrupt_handler_t)NonHandledInterrupt}, // 0 Top of Stack
    {(interrupt_handler_t)NonHandledInterrupt}, // 1 Reset Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 2 NMI Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 3 Hard Fault Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 4 MPU Fault Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 5 Bus Fault Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 6 Usage Fault Handler
    {(interrupt_handler_t)NonHandledInterrupt}, // 7 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, // 8 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, // 9 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, //10 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, //11 SVCall Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //12 Debug Monitor Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //13 Reserved
    {(interrupt_handler_t)NonHandledInterrupt}, //14 PendSV Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //15 SysTick Handler
    {(interrupt_handler_t)NonHandledInterrupt}, //16 Window WatchDog                               
    {(interrupt_handler_t)NonHandledInterrupt}, //17 PVD through EXTI Line detection               
    {(interrupt_handler_t)NonHandledInterrupt}, //18 Tamper and TimeStamps through the EXTI line   
    {(interrupt_handler_t)NonHandledInterrupt}, //19 RTC Wakeup through the EXTI line              
    {(interrupt_handler_t)NonHandledInterrupt}, //20 FLASH                                         
    {(interrupt_handler_t)NonHandledInterrupt}, //21 RCC                                           
    {(interrupt_handler_t)NonHandledInterrupt}, //22 EXTI Line0                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //23 EXTI Line1                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //24 EXTI Line2                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //25 EXTI Line3                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //26 EXTI Line4                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //27 DMA1 Stream 0                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //28 DMA1 Stream 1                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //29 DMA1 Stream 2                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //30 DMA1 Stream 3                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //31 DMA1 Stream 4                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //32 DMA1 Stream 5                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //33 DMA1 Stream 6                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //34 ADC1, ADC2 and ADC3s                          
    {(interrupt_handler_t)NonHandledInterrupt}, //35 CAN1 TX                                       
    {(interrupt_handler_t)NonHandledInterrupt}, //36 CAN1 RX0
    {(interrupt_handler_t)NonHandledInterrupt}, //37 CAN1 RX1                                      
    {(interrupt_handler_t)NonHandledInterrupt}, //38 CAN1 SCE                                      
    {(interrupt_handler_t)NonHandledInterrupt}, //39 External Line[9:5]s                           
    {(interrupt_handler_t)NonHandledInterrupt}, //40 TIM1 Break and TIM9                   
    {(interrupt_handler_t)NonHandledInterrupt}, //41 TIM1 Update and TIM10                 
    {(interrupt_handler_t)NonHandledInterrupt}, //42 TIM1 Trigger and Commutation and TIM11
    {(interrupt_handler_t)NonHandledInterrupt}, //43 TIM1 Capture Compare                          
    {(interrupt_handler_t)NonHandledInterrupt}, //44 TIM2                                          
    {(interrupt_handler_t)NonHandledInterrupt}, //45 TIM3                                          
    {(interrupt_handler_t)NonHandledInterrupt}, //46 TIM4                                          
    {(interrupt_handler_t)NonHandledInterrupt}, //47 I2C1 Event                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //48 I2C1 Error                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //49 I2C2 Event                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //50 I2C2 Error                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //51 SPI1                                          
    {(interrupt_handler_t)NonHandledInterrupt}, //52 SPI2                                          
    {(interrupt_handler_t)NonHandledInterrupt}, //53 USART1                                        
    {(interrupt_handler_t)NonHandledInterrupt}, //54 USART2                                        
    {(interrupt_handler_t)NonHandledInterrupt}, //55 USART3                                        
    {(interrupt_handler_t)NonHandledInterrupt}, //56 External Line[15:10]s                         
    {(interrupt_handler_t)NonHandledInterrupt}, //57 RTC Alarm (A and B) through EXTI Line         
    {(interrupt_handler_t)NonHandledInterrupt}, //58 USB OTG FS Wakeup through EXTI line           
	{(interrupt_handler_t)NonHandledInterrupt}, //59 TIM8 Break and TIM12                  
	{(interrupt_handler_t)NonHandledInterrupt}, //60 TIM8 Update and TIM13                 
	{(interrupt_handler_t)NonHandledInterrupt}, //61 TIM8 Trigger and Commutation and TIM14
	{(interrupt_handler_t)NonHandledInterrupt}, //62 TIM8 Capture Compare                          
	{(interrupt_handler_t)NonHandledInterrupt}, //63 DMA1 Stream7                                  
	{(interrupt_handler_t)NonHandledInterrupt}, //64 FSMC                                          
	{(interrupt_handler_t)NonHandledInterrupt}, //65 SDIO                                          
	{(interrupt_handler_t)NonHandledInterrupt}, //66 TIM5                                          
	{(interrupt_handler_t)NonHandledInterrupt}, //67 SPI3                                          
	{(interrupt_handler_t)NonHandledInterrupt}, //68 UART4                                         
	{(interrupt_handler_t)NonHandledInterrupt}, //69 UART5                                         
	{(interrupt_handler_t)NonHandledInterrupt}, //70 TIM6 and DAC1&2 underrun errors               
	{(interrupt_handler_t)NonHandledInterrupt}, //71 TIM7                   
	{(interrupt_handler_t)NonHandledInterrupt}, //72 DMA2 Stream 0                                 
	{(interrupt_handler_t)NonHandledInterrupt}, //73 DMA2 Stream 1                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //74 DMA2 Stream 2                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //75 DMA2 Stream 3                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //76 DMA2 Stream 4                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //77 Ethernet                                      
    {(interrupt_handler_t)NonHandledInterrupt}, //78 Ethernet Wakeup through EXTI line             
    {(interrupt_handler_t)NonHandledInterrupt}, //79 CAN2 TX                                       
    {(interrupt_handler_t)NonHandledInterrupt}, //80 CAN2 RX0                                      
    {(interrupt_handler_t)NonHandledInterrupt}, //81 CAN2 RX1                                      
    {(interrupt_handler_t)NonHandledInterrupt}, //82 CAN2 SCE                                      
    {(interrupt_handler_t)NonHandledInterrupt}, //83 USB OTG FS                                    
    {(interrupt_handler_t)NonHandledInterrupt}, //84 DMA2 Stream 5                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //85 DMA2 Stream 6                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //86 DMA2 Stream 7                                 
    {(interrupt_handler_t)NonHandledInterrupt}, //87 USART6                                        
    {(interrupt_handler_t)NonHandledInterrupt}, //88 I2C3 event                                    
	{(interrupt_handler_t)NonHandledInterrupt}, //89 I2C3 error                                    
	{(interrupt_handler_t)NonHandledInterrupt}, //90 USB OTG HS End Point 1 Out                    
	{(interrupt_handler_t)NonHandledInterrupt}, //91 USB OTG HS End Point 1 In                     
	{(interrupt_handler_t)NonHandledInterrupt}, //92 USB OTG HS Wakeup through EXTI                
	{(interrupt_handler_t)NonHandledInterrupt}, //93 USB OTG HS                                    
	{(interrupt_handler_t)NonHandledInterrupt}, //94 DCMI                                          
	{(interrupt_handler_t)NonHandledInterrupt}, //95 CRYP crypto                                   
	{(interrupt_handler_t)NonHandledInterrupt}, //96 Hash and Rng
	{(interrupt_handler_t)NonHandledInterrupt}, //97 FPU
};
/*
**
*/
void CORT_IntRoutine(t_u8 id)
{
	if (id > 1 && id < CORT_ARRAYSIZE(vec_tab)){
		vec_tab[id](id);
	}
}

/*
**
*/
t_s8  CORT_Interrupt_Register(t_u16 idx,void (*task_entry)(t_u16))
{
	CORT_EnterCritical();
	if (idx > 1 && idx < CORT_ARRAYSIZE(vec_tab))
	{
		vec_tab[idx] = task_entry;
		CORT_ExitCritical();
		return CORT_OK;
	}
	CORT_ExitCritical();
	return CORT_ERROR;
}
