;******************** (C) COPYRIGHT 2011 STMicroelectronics ********************
;* File Name          : startup_stm32f4xx.s
;* Author             : MCD Application Team
;* Version            : V1.0.0RC1
;* Date               : 25-August-2011
;* Description        : STM32F4xx devices vector table for MDK-ARM toolchain. 
;*                      This module performs:
;*                      - Set the initial SP
;*                      - Set the initial PC == Reset_Handler
;*                      - Set the vector table entries with the exceptions ISR address
;*                      - Branches to __main in the C library (which eventually
;*                        calls main()).
;*                      After Reset the CortexM4 processor is in Thread mode,
;*                      priority is Privileged, and the Stack is set to Main.
;* <<< Use Configuration Wizard in Context Menu >>>   
;*******************************************************************************
; THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
; WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
; AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
; INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
; CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
; INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
;*******************************************************************************

; Amount of memory (in bytes) allocated for Stack
; Tailor this value to your application needs
; <h> Stack Configuration
;   <o> Stack Size (in Bytes) <0x0-0xFFFFFFFF:8>
; </h>

Stack_Size      EQU     0x00000400

                AREA    STACK, NOINIT, READWRITE, ALIGN=3
Stack_Mem       SPACE   Stack_Size
__initial_sp


; <h> Heap Configuration
;   <o>  Heap Size (in Bytes) <0x0-0xFFFFFFFF:8>
; </h>

Heap_Size       EQU     0x00000200

                AREA    HEAP, NOINIT, READWRITE, ALIGN=3
__heap_base
Heap_Mem        SPACE   Heap_Size
__heap_limit

                PRESERVE8
                THUMB


; Vector Table Mapped to Address 0 at Reset
                AREA    RESET, DATA, READONLY
                EXTERN  CORT_PendSV
                EXTERN	CORT_GlobalInt
                EXPORT  __Vectors
                EXPORT  __Vectors_End
                EXPORT  __Vectors_Size

__Vectors       DCD     __initial_sp            ; 0 Top of Stack
                DCD     Reset_Handler           ; 1 Reset Handler
                DCD     CORT_GlobalInt          ; 2 NMI Handler
                DCD     HardFault_Handler       ; 3 Hard Fault Handler
                DCD     CORT_GlobalInt          ; 4 MPU Fault Handler
                DCD     CORT_GlobalInt          ; 5 Bus Fault Handler
                DCD     CORT_GlobalInt          ; 6 Usage Fault Handler
                DCD     0                       ; 7 Reserved
                DCD     0                       ; 8 Reserved
                DCD     0                       ; 9 Reserved
                DCD     0                       ;10 Reserved
                DCD     CORT_GlobalInt          ;11 SVCall Handler
                DCD     CORT_GlobalInt          ;12 Debug Monitor Handler
                DCD     0                       ;13 Reserved
                DCD     CORT_PendSV             ;14 PendSV Handler
                DCD     CORT_GlobalInt          ;15 SysTick Handler
                DCD     CORT_GlobalInt          ;16 Window WatchDog                                        
                DCD     CORT_GlobalInt          ;17 PVD through EXTI Line detection                        
                DCD     CORT_GlobalInt          ;18 Tamper and TimeStamps through the EXTI line            
                DCD     CORT_GlobalInt          ;19 RTC Wakeup through the EXTI line                       
                DCD     CORT_GlobalInt          ;20 FLASH                                           
                DCD     CORT_GlobalInt          ;21 RCC                                             
                DCD     CORT_GlobalInt          ;22 EXTI Line0                                             
                DCD     CORT_GlobalInt          ;23 EXTI Line1                                             
                DCD     CORT_GlobalInt          ;24 EXTI Line2                                             
                DCD     CORT_GlobalInt          ;25 EXTI Line3                                             
                DCD     CORT_GlobalInt          ;26 EXTI Line4                                             
                DCD     CORT_GlobalInt          ;27 DMA1 Stream 0                                   
                DCD     CORT_GlobalInt          ;28 DMA1 Stream 1                                   
                DCD     CORT_GlobalInt          ;29 DMA1 Stream 2                                   
                DCD     CORT_GlobalInt          ;30 DMA1 Stream 3                                   
                DCD     CORT_GlobalInt          ;31 DMA1 Stream 4                                   
                DCD     CORT_GlobalInt          ;32 DMA1 Stream 5                                   
                DCD     CORT_GlobalInt          ;33 DMA1 Stream 6                                   
                DCD     CORT_GlobalInt          ;34 ADC1, ADC2 and ADC3s                            
                DCD     CORT_GlobalInt          ;35 CAN1 TX                                                
                DCD     CORT_GlobalInt          ;36 CAN1 RX0                                               
                DCD     CORT_GlobalInt          ;37 CAN1 RX1                                               
                DCD     CORT_GlobalInt          ;38 CAN1 SCE                                               
                DCD     CORT_GlobalInt          ;39 External Line[9:5]s                                    
                DCD     CORT_GlobalInt          ;40 TIM1 Break and TIM9                   
                DCD     CORT_GlobalInt          ;41 TIM1 Update and TIM10                 
                DCD     CORT_GlobalInt          ;42 TIM1 Trigger and Commutation and TIM11
                DCD     CORT_GlobalInt          ;43 TIM1 Capture Compare                                   
                DCD     CORT_GlobalInt          ;44 TIM2                                            
                DCD     CORT_GlobalInt          ;45 TIM3                                            
                DCD     CORT_GlobalInt          ;46 TIM4                                            
                DCD     CORT_GlobalInt          ;47 I2C1 Event                                             
                DCD     CORT_GlobalInt          ;48 I2C1 Error                                             
                DCD     CORT_GlobalInt          ;49 I2C2 Event                                             
                DCD     CORT_GlobalInt          ;50 I2C2 Error                                               
                DCD     CORT_GlobalInt          ;51 SPI1                                            
                DCD     CORT_GlobalInt          ;52 SPI2                                            
                DCD     CORT_GlobalInt          ;53 USART1                                          
                DCD     CORT_GlobalInt          ;54 USART2                                          
                DCD     CORT_GlobalInt          ;55 USART3                                          
                DCD     CORT_GlobalInt          ;56 External Line[15:10]s                                  
                DCD     CORT_GlobalInt          ;57 RTC Alarm (A and B) through EXTI Line                  
                DCD     CORT_GlobalInt          ;58 USB OTG FS Wakeup through EXTI line                        
                DCD     CORT_GlobalInt          ;59 TIM8 Break and TIM12                  
                DCD     CORT_GlobalInt          ;60 TIM8 Update and TIM13                 
                DCD     CORT_GlobalInt          ;61 TIM8 Trigger and Commutation and TIM14
                DCD     CORT_GlobalInt          ;62 TIM8 Capture Compare                                   
                DCD     CORT_GlobalInt          ;63 DMA1 Stream7                                           
                DCD     CORT_GlobalInt          ;64 FSMC                                            
                DCD     CORT_GlobalInt          ;65 SDIO                                            
                DCD     CORT_GlobalInt          ;66 TIM5                                            
                DCD     CORT_GlobalInt          ;67 SPI3                                            
                DCD     CORT_GlobalInt          ;68 UART4                                           
                DCD     CORT_GlobalInt          ;69 UART5                                           
                DCD     CORT_GlobalInt          ;70 TIM6 and DAC1&2 underrun errors                   
                DCD     CORT_GlobalInt          ;71 TIM7                   
                DCD     CORT_GlobalInt          ;72 DMA2 Stream 0                                   
                DCD     CORT_GlobalInt          ;73 DMA2 Stream 1                                   
                DCD     CORT_GlobalInt          ;74 DMA2 Stream 2                                   
                DCD     CORT_GlobalInt          ;75 DMA2 Stream 3                                   
                DCD     CORT_GlobalInt          ;76 DMA2 Stream 4                                   
                DCD     CORT_GlobalInt          ;77 Ethernet                                        
                DCD     CORT_GlobalInt          ;78 Ethernet Wakeup through EXTI line                      
                DCD     CORT_GlobalInt          ;79 CAN2 TX                                                
                DCD     CORT_GlobalInt          ;80 CAN2 RX0                                               
                DCD     CORT_GlobalInt          ;81 CAN2 RX1                                               
                DCD     CORT_GlobalInt          ;82 CAN2 SCE                                               
                DCD     CORT_GlobalInt          ;83 USB OTG FS                                      
                DCD     CORT_GlobalInt          ;84 DMA2 Stream 5                                   
                DCD     CORT_GlobalInt          ;85 DMA2 Stream 6                                   
                DCD     CORT_GlobalInt          ;86 DMA2 Stream 7                                   
                DCD     CORT_GlobalInt          ;87 USART6                                           
                DCD     CORT_GlobalInt          ;88 I2C3 event                                             
                DCD     CORT_GlobalInt          ;89 I2C3 error                                             
                DCD     CORT_GlobalInt          ;90 USB OTG HS End Point 1 Out                      
                DCD     CORT_GlobalInt          ;91 USB OTG HS End Point 1 In                       
                DCD     CORT_GlobalInt          ;92 USB OTG HS Wakeup through EXTI                         
                DCD     CORT_GlobalInt          ;93 USB OTG HS                                      
                DCD     CORT_GlobalInt          ;94 DCMI                                            
                DCD     CORT_GlobalInt          ;95 CRYP crypto                                     
                DCD     CORT_GlobalInt          ;96 Hash and Rng
                DCD     CORT_GlobalInt          ;97 FPU
                         
__Vectors_End

__Vectors_Size  EQU  __Vectors_End - __Vectors

                AREA    |.text|, CODE, READONLY

; Reset handler
Reset_Handler    PROC
                 EXPORT  Reset_Handler             [WEAK]
        IMPORT  SystemInit
        IMPORT  __main

                 ;FPU settings
                 LDR     R0, =0xE000ED88           ; Enable CP10,CP11
                 LDR     R1,[R0]
                 ORR     R1,R1,#(0xF << 20)
                 STR     R1,[R0]

                 LDR     R0, =SystemInit
                 BLX     R0
                 LDR     R0, =__main
                 BX      R0
                 ENDP

; Dummy Exception Handlers (infinite loops which can be modified)

NMI_Handler     PROC
                EXPORT  NMI_Handler                [WEAK]
                B       .
                ENDP
HardFault_Handler\
                PROC
                EXPORT  HardFault_Handler          [WEAK]
                B       .
                ENDP
MemManage_Handler\
                PROC
                EXPORT  MemManage_Handler          [WEAK]
                B       .
                ENDP
BusFault_Handler\
                PROC
                EXPORT  BusFault_Handler           [WEAK]
                B       .
                ENDP
UsageFault_Handler\
                PROC
                EXPORT  UsageFault_Handler         [WEAK]
                B       .
                ENDP
SVC_Handler     PROC
                EXPORT  SVC_Handler                [WEAK]
                B       .
                ENDP
DebugMon_Handler\
                PROC
                EXPORT  DebugMon_Handler           [WEAK]
                B       .
                ENDP
PendSV_Handler  PROC
                EXPORT  PendSV_Handler             [WEAK]
                B       .
                ENDP
SysTick_Handler PROC
                EXPORT  SysTick_Handler            [WEAK]
                B       .
                ENDP

Default_Handler PROC

                EXPORT  WWDG_IRQHandler                   [WEAK]                                        
                EXPORT  PVD_IRQHandler                    [WEAK]                      
                EXPORT  TAMP_STAMP_IRQHandler             [WEAK]         
                EXPORT  RTC_WKUP_IRQHandler               [WEAK]                     
                EXPORT  FLASH_IRQHandler                  [WEAK]                                         
                EXPORT  RCC_IRQHandler                    [WEAK]                                            
                EXPORT  EXTI0_IRQHandler                  [WEAK]                                            
                EXPORT  EXTI1_IRQHandler                  [WEAK]                                             
                EXPORT  EXTI2_IRQHandler                  [WEAK]                                            
                EXPORT  EXTI3_IRQHandler                  [WEAK]                                           
                EXPORT  EXTI4_IRQHandler                  [WEAK]                                            
                EXPORT  DMA1_Stream0_IRQHandler           [WEAK]                                
                EXPORT  DMA1_Stream1_IRQHandler           [WEAK]                                   
                EXPORT  DMA1_Stream2_IRQHandler           [WEAK]                                   
                EXPORT  DMA1_Stream3_IRQHandler           [WEAK]                                   
                EXPORT  DMA1_Stream4_IRQHandler           [WEAK]                                   
                EXPORT  DMA1_Stream5_IRQHandler           [WEAK]                                   
                EXPORT  DMA1_Stream6_IRQHandler           [WEAK]                                   
                EXPORT  ADC_IRQHandler                    [WEAK]                         
                EXPORT  CAN1_TX_IRQHandler                [WEAK]                                                
                EXPORT  CAN1_RX0_IRQHandler               [WEAK]                                               
                EXPORT  CAN1_RX1_IRQHandler               [WEAK]                                                
                EXPORT  CAN1_SCE_IRQHandler               [WEAK]                                                
                EXPORT  EXTI9_5_IRQHandler                [WEAK]                                    
                EXPORT  TIM1_BRK_TIM9_IRQHandler          [WEAK]                  
                EXPORT  TIM1_UP_TIM10_IRQHandler          [WEAK]                
                EXPORT  TIM1_TRG_COM_TIM11_IRQHandler     [WEAK] 
                EXPORT  TIM1_CC_IRQHandler                [WEAK]                                   
                EXPORT  TIM2_IRQHandler                   [WEAK]                                            
                EXPORT  TIM3_IRQHandler                   [WEAK]                                            
                EXPORT  TIM4_IRQHandler                   [WEAK]                                            
                EXPORT  I2C1_EV_IRQHandler                [WEAK]                                             
                EXPORT  I2C1_ER_IRQHandler                [WEAK]                                             
                EXPORT  I2C2_EV_IRQHandler                [WEAK]                                            
                EXPORT  I2C2_ER_IRQHandler                [WEAK]                                               
                EXPORT  SPI1_IRQHandler                   [WEAK]                                           
                EXPORT  SPI2_IRQHandler                   [WEAK]                                            
                EXPORT  USART1_IRQHandler                 [WEAK]                                          
                EXPORT  USART2_IRQHandler                 [WEAK]                                          
                EXPORT  USART3_IRQHandler                 [WEAK]                                         
                EXPORT  EXTI15_10_IRQHandler              [WEAK]                                  
                EXPORT  RTC_Alarm_IRQHandler              [WEAK]                  
                EXPORT  OTG_FS_WKUP_IRQHandler            [WEAK]                        
                EXPORT  TIM8_BRK_TIM12_IRQHandler         [WEAK]                 
                EXPORT  TIM8_UP_TIM13_IRQHandler          [WEAK]                 
                EXPORT  TIM8_TRG_COM_TIM14_IRQHandler     [WEAK] 
                EXPORT  TIM8_CC_IRQHandler                [WEAK]                                   
                EXPORT  DMA1_Stream7_IRQHandler           [WEAK]                                          
                EXPORT  FSMC_IRQHandler                   [WEAK]                                             
                EXPORT  SDIO_IRQHandler                   [WEAK]                                             
                EXPORT  TIM5_IRQHandler                   [WEAK]                                             
                EXPORT  SPI3_IRQHandler                   [WEAK]                                             
                EXPORT  UART4_IRQHandler                  [WEAK]                                            
                EXPORT  UART5_IRQHandler                  [WEAK]                                            
                EXPORT  TIM6_DAC_IRQHandler               [WEAK]                   
                EXPORT  TIM7_IRQHandler                   [WEAK]                    
                EXPORT  DMA2_Stream0_IRQHandler           [WEAK]                                  
                EXPORT  DMA2_Stream1_IRQHandler           [WEAK]                                   
                EXPORT  DMA2_Stream2_IRQHandler           [WEAK]                                    
                EXPORT  DMA2_Stream3_IRQHandler           [WEAK]                                    
                EXPORT  DMA2_Stream4_IRQHandler           [WEAK]                                 
                EXPORT  ETH_IRQHandler                    [WEAK]                                         
                EXPORT  ETH_WKUP_IRQHandler               [WEAK]                     
                EXPORT  CAN2_TX_IRQHandler                [WEAK]                                               
                EXPORT  CAN2_RX0_IRQHandler               [WEAK]                                               
                EXPORT  CAN2_RX1_IRQHandler               [WEAK]                                               
                EXPORT  CAN2_SCE_IRQHandler               [WEAK]                                               
                EXPORT  OTG_FS_IRQHandler                 [WEAK]                                       
                EXPORT  DMA2_Stream5_IRQHandler           [WEAK]                                   
                EXPORT  DMA2_Stream6_IRQHandler           [WEAK]                                   
                EXPORT  DMA2_Stream7_IRQHandler           [WEAK]                                   
                EXPORT  USART6_IRQHandler                 [WEAK]                                           
                EXPORT  I2C3_EV_IRQHandler                [WEAK]                                              
                EXPORT  I2C3_ER_IRQHandler                [WEAK]                                              
                EXPORT  OTG_HS_EP1_OUT_IRQHandler         [WEAK]                      
                EXPORT  OTG_HS_EP1_IN_IRQHandler          [WEAK]                      
                EXPORT  OTG_HS_WKUP_IRQHandler            [WEAK]                        
                EXPORT  OTG_HS_IRQHandler                 [WEAK]                                      
                EXPORT  DCMI_IRQHandler                   [WEAK]                                             
                EXPORT  CRYP_IRQHandler                   [WEAK]                                     
                EXPORT  HASH_RNG_IRQHandler               [WEAK]
                EXPORT  FPU_IRQHandler                    [WEAK]                

WWDG_IRQHandler                                                       
PVD_IRQHandler                                      
TAMP_STAMP_IRQHandler                  
RTC_WKUP_IRQHandler                                
FLASH_IRQHandler                                                       
RCC_IRQHandler                                                            
EXTI0_IRQHandler                                                          
EXTI1_IRQHandler                                                           
EXTI2_IRQHandler                                                          
EXTI3_IRQHandler                                                         
EXTI4_IRQHandler                                                          
DMA1_Stream0_IRQHandler                                       
DMA1_Stream1_IRQHandler                                          
DMA1_Stream2_IRQHandler                                          
DMA1_Stream3_IRQHandler                                          
DMA1_Stream4_IRQHandler                                          
DMA1_Stream5_IRQHandler                                          
DMA1_Stream6_IRQHandler                                          
ADC_IRQHandler                                         
CAN1_TX_IRQHandler                                                            
CAN1_RX0_IRQHandler                                                          
CAN1_RX1_IRQHandler                                                           
CAN1_SCE_IRQHandler                                                           
EXTI9_5_IRQHandler                                                
TIM1_BRK_TIM9_IRQHandler                        
TIM1_UP_TIM10_IRQHandler                      
TIM1_TRG_COM_TIM11_IRQHandler  
TIM1_CC_IRQHandler                                               
TIM2_IRQHandler                                                           
TIM3_IRQHandler                                                           
TIM4_IRQHandler                                                           
I2C1_EV_IRQHandler                                                         
I2C1_ER_IRQHandler                                                         
I2C2_EV_IRQHandler                                                        
I2C2_ER_IRQHandler                                                           
SPI1_IRQHandler                                                          
SPI2_IRQHandler                                                           
USART1_IRQHandler                                                       
USART2_IRQHandler                                                       
USART3_IRQHandler                                                      
EXTI15_10_IRQHandler                                            
RTC_Alarm_IRQHandler                            
OTG_FS_WKUP_IRQHandler                                
TIM8_BRK_TIM12_IRQHandler                      
TIM8_UP_TIM13_IRQHandler                       
TIM8_TRG_COM_TIM14_IRQHandler  
TIM8_CC_IRQHandler                                               
DMA1_Stream7_IRQHandler                                                 
FSMC_IRQHandler                                                            
SDIO_IRQHandler                                                            
TIM5_IRQHandler                                                            
SPI3_IRQHandler                                                            
UART4_IRQHandler                                                          
UART5_IRQHandler                                                          
TIM6_DAC_IRQHandler                            
TIM7_IRQHandler                              
DMA2_Stream0_IRQHandler                                         
DMA2_Stream1_IRQHandler                                          
DMA2_Stream2_IRQHandler                                           
DMA2_Stream3_IRQHandler                                           
DMA2_Stream4_IRQHandler                                        
ETH_IRQHandler                                                         
ETH_WKUP_IRQHandler                                
CAN2_TX_IRQHandler                                                           
CAN2_RX0_IRQHandler                                                          
CAN2_RX1_IRQHandler                                                          
CAN2_SCE_IRQHandler                                                          
OTG_FS_IRQHandler                                                    
DMA2_Stream5_IRQHandler                                          
DMA2_Stream6_IRQHandler                                          
DMA2_Stream7_IRQHandler                                          
USART6_IRQHandler                                                        
I2C3_EV_IRQHandler                                                          
I2C3_ER_IRQHandler                                                          
OTG_HS_EP1_OUT_IRQHandler                           
OTG_HS_EP1_IN_IRQHandler                            
OTG_HS_WKUP_IRQHandler                                
OTG_HS_IRQHandler                                                   
DCMI_IRQHandler                                                            
CRYP_IRQHandler                                                    
HASH_RNG_IRQHandler
FPU_IRQHandler                                                 

                B       .

                ENDP

                ALIGN

;*******************************************************************************
; User Stack and Heap initialization
;*******************************************************************************
                 IF      :DEF:__MICROLIB
                
                 EXPORT  __initial_sp
                 EXPORT  __heap_base
                 EXPORT  __heap_limit
                
                 ELSE
                
                 IMPORT  __use_two_region_memory
                 EXPORT  __user_initial_stackheap
                 
__user_initial_stackheap

                 LDR     R0, =  Heap_Mem
                 LDR     R1, =(Stack_Mem + Stack_Size)
                 LDR     R2, = (Heap_Mem +  Heap_Size)
                 LDR     R3, = Stack_Mem
                 BX      LR

                 ALIGN

                 ENDIF

                 END

;******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE*****
