/*
 * Copyright (C) Yao Jun 2013
 * <nter@tom.com> 
 * <http://CortOS.sourceforge.net/>
 *
 * SortOS is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SortOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "config.h"

extern void CORT_Tick(void);

#define TIM4_PERIOD       124
#define F_CPU 8000000UL

/*
**  Interrupt for Timer4
*/
void dev_hwinit_irq(t_u16 idx)
{
    /* Cleat Interrupt Pending bit */
  	TIM4_ClearITPendingBit(TIM4_IT_UPDATE);
  
	CORT_Tick();
}

/*
**  Initialize Hardware
*/
void dev_hwinit_init(void)
{
	/* Fmaster = 8MHz */
	/* Configure the Fcpu to DIV1*/ 
	CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV2); 
	
	/* Initilize the CLock controller according to CLK_InitStructure */ 
	CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSE, DISABLE, CLK_CURRENTCLOCKSTATE_DISABLE);
	
	CLK_HSECmd(ENABLE); 
}
/*
** Start timer
*/
void dev_hwinit_start(void)
{
	CORT_Interrupt_Register(25, dev_hwinit_irq);
	
	TIM4_ARRPreloadConfig(ENABLE);
	TIM4_PrescalerConfig(TIM4_PRESCALER_32,TIM4_PSCRELOADMODE_IMMEDIATE);  //128Ƶ
	TIM4_SetAutoreload((uint8_t)(F_CPU/32/CORT_TICK_PER_SEC));
	TIM4_Cmd(ENABLE);                   
	TIM4_ITConfig(TIM4_IT_UPDATE, ENABLE);  
}

