;
; Copyright (C) Yao Jun 2011
; <nter@tom.com> 
; <http://CortOS.sourceforge.net/>
;
; SortOS is free software: you can redistribute it and/or modify it
; under the terms of the GNU Lesser General Public License as published
; by the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
; 
; SortOS is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See the GNU Lesser General Public License for more details.
; 
; You should have received a copy of the GNU Lesser General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;
; Contents:
;   CORT_StartHigh          - 
;   CORT_CtxSw              - 
;

	NAME OS_CPU_A
#include "vregs.inc" 

;**************************************************************************
;  Define
;**************************************************************************
	EXTERN  CORT_EnterInt
    EXTERN  CORT_ExitInt
	EXTERN  CORT_Running
	EXTERN  CORT_IntRoutine
	EXTERN  CORT_SearchRdy
	EXTERN  CORT_CurTcb
	EXTERN  CORT_IntNesting
	EXTERN  CORT_IntTsk_top
	EXTERN  CORT_RTim_Run
    EXTERN  CORT_RTim_Stop
	EXTERN  CORT_SwHighTask
	EXTERN	CORT_IrqIdx
	EXTERN  CORT_EnterCritical
	EXTERN  CORT_ExitCritical

	PUBLIC  CORT_GlobalInit
	PUBLIC  CORT_StartHigh
	PUBLIC  CORT_CtxSw
;**************************************************************************
;  Macro
;**************************************************************************
PUSH_EX_REGS  MACRO        
	push s:?b0
	push s:?b1
	push s:?b2
	push s:?b3
	push s:?b4
	push s:?b5
	push s:?b6
	push s:?b7
	push s:?b8
	push s:?b9
	push s:?b10
	push s:?b11
	push s:?b12
	push s:?b13
	push s:?b14
	push s:?b15
	ENDM

POP_EX_REGS  MACRO 
	pop s:?b15
	pop s:?b14
	pop s:?b13
	pop s:?b12
	pop s:?b11
	pop s:?b10
	pop s:?b9
	pop s:?b8
	pop s:?b7
	pop s:?b6
	pop s:?b5
	pop s:?b4
	pop s:?b3
	pop s:?b2
	pop s:?b1
	pop s:?b0
	ENDM	

PUSH_NOR_REG	MACRO
	PUSHW	Y
	PUSHW	X        
	PUSH	A
	PUSH	CC
	ENDM

POP_NOR_REG	MACRO
	POP		CC	
	POP		A
	POPW	X
	POPW	Y
	ENDM

SAVE_STK_PTR	MACRO
	LDW 	Y,L:CORT_CurTcb
	LDW		X,SP
	LDW		(Y),X
	ENDM

LOAD_STK_PTR	MACRO
	LDW     Y, L:CORT_CurTcb
	LDW     Y, (Y)
	LDW     SP, Y
	ENDM

;**************************************************************************
;  Funtion
;**************************************************************************

	SECTION `.near_func.text`:CODE:ROOT(0)
CORT_StartHigh:	
;	Disable Interrupt
	SIM
	
;	CORT_Running = 1
	MOV		L:CORT_Running,#1
	
;	CORT_SwHighTask();
	CALL	CORT_SwHighTask
	
;	CORT_RTim_Run();
	CALL	CORT_RTim_Run
	
;	Load Stack Printer
	LOAD_STK_PTR
	
;	Switch Task
	POP_EX_REGS
	
;	Enable Interrupt
	IRET

CORT_CtxSw:
;	Save Stack Printer
	PUSH #0
	PUSH_NOR_REG
	PUSH_EX_REGS
	
;	Save Stack Pointer
	SAVE_STK_PTR
	
;	CORT_RTim_Stop();
	CALL	CORT_RTim_Stop
	
;	CORT_SwHighTask();
	CALL	CORT_SwHighTask
	
;	CORT_RTim_Run();
	CALL	CORT_RTim_Run
	
;	Load Stack Printer
	LOAD_STK_PTR
	
;	Switch Task
	POP_EX_REGS
	
;	Enable Interrupt
	IRET

CORT_GlobalInit:
;	if ((++CORT_IntNesting)==1)
	LD		A , L:CORT_IntNesting
	ADD		A , #1
	LD		L:CORT_IntNesting, A
	CP		A , #1
	JRNE	ENTER_INTROUTINE
;	{
;		Save Stack Printer
		PUSH_EX_REGS
		SAVE_STK_PTR
		
;		CORT_RTim_Stop();
		CALL	CORT_RTim_Stop
		
;		CORT_EnterInt();
		CALL 	CORT_EnterInt
;	}
ENTER_INTROUTINE
;	CORT_IntRoutine();
	LD		A, CORT_IrqIdx
    CALL	CORT_IntRoutine
	
;	Disable Interrupt
	SIM

;	if ((--CORT_IntNesting))
	LD		A , L:CORT_IntNesting
	ADD		A , #0XFF
	LD		L:CORT_IntNesting, A
	TNZ		A
	JREQ	ENTER_TASK
;	{
;		return;
		IRET
;	}else{
ENTER_TASK
;		CORT_ExitInt()
		CALL	CORT_ExitInt
		
;		CORT_SwHighTask();
		CALL	CORT_SwHighTask
		
;		CORT_RTim_Run();
		CALL	CORT_RTim_Run
		
;		Load Stack Printer
		LOAD_STK_PTR				; restore stack pointer
		
;		Switch Task
		POP_EX_REGS					; restore registers
		IRET
;	}


	END
	